#!/usr/bin/perl
#Made by Tarjei Westrum and Vidar A. Grnland at HiG  2003
#
#
#The aim for this  script is to generate the Nagios configuration
#file hostgroups.cfg based on information collected by other scripts
#

print `rm -f hostgroups.cfg`;			#Removes hostgroups.cfg if it allready exist
$date = `date`;					#The date the script was executed (used later)

open ( INFILE1, "<hoster.txt" ) || die "ERROR, unable to open hoster.txt\n";
	$u=0;					#Counter
	while(<INFILE1>)  {			#As long as there is something in the file do:
		chomp;
				#Splits one line into several variables
		($a, $b, $c, $d, $e, $f, $g, $h, $i, $j) = split (/\./, $_, 10);
		$hostname = "$e";			#Makes it easier to follow the code but not necessary
		open (INFILE2, "<hoster.txt" ) || die "ERROR, unable to open hoster.txt";

		while(<INFILE2>) {			#Open the file again
		chomp;
		($k, $l, $m, $n, $o, $p, $q, $r, $s, $t) = split (/\./, $_, 10);
		$parentname = "$t";			#Makes it easier to follow the code but not necessary
			if ($hostname eq $parentname) {
				@tkservere[$u] = "$e";	#Puts all LTSP-servers into a array called tkservere
			}
		}
		if(@tkservere[$u] eq '') {		#Removes empty elements in the tkserver-array
			$u--;
		}
		$u++;					#Moves the pointer to the next element in array tkservere
		close(INFILE2);				#Closes INFILE2
	}
close(INFILE1);						#Closes INFILE1


#
#The next INFILE is just to put all of the hosts on the 10.0.0.0 net into a array
#
$xx=0;		
open (INFILE3, "<hoster.txt" ) || die "ERROR, unable to open hoster.txt\n";
while (<INFILE3>) {					#While not end of file do:
	chomp;
	($a, $b, $c, $d, $e, $f, $g, $h, $i, $j) = split (/\./, $_, 10);
	if ($a != '192') {				#If the IP-address doesn't start with 192 then:
		@temp[$xx] = "$e";			#Puts the hostname into a array called temp
		$xx++;					#Moves the array-pointer to the next element
	}
}
close(INFILE3);

#
#This sequence is to sort all workstations into a array, by comparing the array that contains all of the hosts on the 
#10.0.0.0 net with the array of LTSP-servers (@tkservere). If a host in the array @temp is not represented in the array
#@tkservere it must be a workstation 
#
$k = 0;
for ($i=0; $i < $xx; $i++) {				#Counts up the elements in @temp
	$status = 0;					#Status variable used later
	for ($j=0; $j < $u; $j++) {			#Counts up the elements in @tkservere
		if ( @temp[$i]  eq @tkservere[$j]) {	#Checks if one element in @temp exists in any of the elements in the array @tkservere
			$status = 1;			#If it does, status is set to 1
		}
	}
	if ($status == 0 ) {				#If the hostname do not match any of the elements in the array @tkservere
		@arbeidsstasjoner[$k] = @temp[$i];	#it is a workstation, and they are put in a array named @arbeidsstasjoner
		$k++;								
	}										
}
my $listSeparator = $";		#This is a function to separate elements in an array with comma when they are printed out
$" = ',';					
							#Writing the result to the file hostgroups.cfg
open(OUTFILE, ">>hostgroups.cfg") || "ERROR, unable to write to file (hostgroups.cfg)\n";


#*****************Making hostgroups.cfg********************************************************

print OUTFILE "################################################################################
# Sample object config file for Nagios 1.0
#
# Read the documentation for more information on this configuration file.  I've
# provided some comments here, but things may not be so clear without further
# explanation, so make sure to read the HTML documentation!
#
# Last Modified: $date#
################################################################################


################################################################################
# HOST GROUP DEFINITIONS
#
# SYNTAX:
#
################################################################################

# 'linux-boxes' host group definition
define hostgroup{
       	hostgroup_name  tynnklientservere
       	alias           Intern nett
       	contact_groups  nagios
       	members         @tkservere

}

define hostgroup{
       	hostgroup_name  arbeidsstasjoner
       	alias           Arbeidsstasjoner
       	contact_groups  nagios
       	members         @arbeidsstasjoner
}
";

close(OUTFILE);

print `rm -f hoster.txt`;		#Delete the file hoster.txt, we don't need it any more!
