#!/usr/bin/perl
#Made by Vidar Grnland and Tarje Westrum at HiG  2003
#

($a, $b, $c, $d) = split (/\./, $ARGV[0]);	#Spilt the IP-address, which is the argument to the script, into 4 peaces
if ($d < "110") {				#The following three checks generates hostname extractet from the IP-address
	$tmp = ($d - 100);			
	$parent = "dhcp-00$tmp";
}
elsif ($d <"200" && $d >"109")  {
	$tmp = ($d - 100);
	$parent = "dhcp-0$tmp";
}
elsif ($d > "199" && $d < "255") {
	$tmp = ($d - 100);
	$parent = "dhcp-$tmp";
}

print `ping -c 2 192.168.0.255 > pingresTKS.txt`;	#Ping broadcast at the LTSP-net, and write the result to the file (pingresTKS.txt)
sleep(2);						#Avoid conflict between read/write in the file pingresTKS.txt
print `rm -f hosterTKS$d.txt`;				#Delete the file hosterTKSxxx.txt, if it already exists
open(INFILE, "<pingresTKS.txt") || die "ERROR, unable to open file pingresTKS.txt\n"; 	#Open the file pingresTKS.txt

	while (<INFILE>) {					#As long as the file contains any data
		chomp;						#Remove \n at the end of the line
		if (m/(\d+)\.(\d+)\.(\d+)\.(\d+)/) {		#If it finds an IP-address, do the following:
			$ipadr = "$1.$2.$3.$4";			#Put the IP-addr in the variable $ipadr

			if (($4 != "255") && ($4 != "254")) {	#Checking if the IP-addr do not end at 254/255 (irrelevant addresses)
				if ($4 < 100) {			#If the last segment in the IP address is less than 100 do:
					$e = "0$4";		#$e => 0xx, xx is the same as the xx in 192.168.0.xx
				}else {$e = $4;}		#If the last segment is larger than 100 do:
								#ltsp-xxx, where xxx is the xxx in 192.168.0.xxx
				$hostname = "ltsp-$e";		#$hostname => ltsp-0xx or ltsp-xxx
								
#Writes to a new file for each LTSP-server. $d is the last segment of the IP address of the server.
				open(OUTFILE, ">>hosterTKS$d.txt") || "ERROR, unable to write to file (hosterTKS$d.txt)\n";
					print OUTFILE "$ipadr.$hostname.$ARGV[0].$parent\n";	#Writes to file
				close(OUTFILE);
			}
		}
	}
close(INFILE);	
print `rm -f pingresTKS.txt`;	#Deletes the file pingresTKS.txt since this is not needed any more


#**************************************NRPE config**************************************************************
#This part generates the command.cfg file used by the NRPE daemon. The main purpose of this part is 
#to find out the IP adresses of the first and last LTSP-client, and put this in as an argument for
#the check_dead plugin


open(INFILE, "<hosterTKS$d.txt") || die "ERROR, unable to open file hosterTKS$d\n"; {
	$n = 0;
	while(<INFILE>)  {	
 		chomp;
		($aa, $bb, $cc, $dd, $ee, $ff, $gg, $hh, $ii, $jj) = split (/\./, $_, 10);
		$tkIP = "$aa.$bb.$cc.$dd";
		$ipnr{$tkIP}++;
	}
}
close(INFILE);

@keys = sort keys %ipnr;	#Sorts the hash table $ipnr in increasing order
print "Thin clients found on server $ARGV[0]\n";
foreach (@keys) {		#Prints out all the LTSP-clients which lies in @keys
	print ($_);
	print "\n";
}
$first = @keys[0];		#$first => the LTSP-client with the lowest IP address
$rr = $#keys;			#$rr => the lenght of array @keys (number of elements)
$last = @keys[$rr];		#$last => the LTSP-client with the highest IP address

print `rm -f command.cfg`;	#Deletes command.cfg in case it allready exists

open(OUTFILE, ">>command.cfg") || "ERROR, unable to write to file (command.cfg)\n";  {
	print OUTFILE "# Plugin Configuration for netsaint.
#
# Ben Bell <bjb@debian.org> 20/11/01
#
# Debian doesn't use this file by default. Instead, the command definitions
# for have been split into seperate files in /usr/share/netsaint/pluginconfig
# and are automatically merged into /etc/netsaint/plugins-auto.cfg by
# update-netsaint(8)
# The original upstream version of this file can be found in
# /usr/share/doc/netsaint-plugins/examples
#
# Feel free to add local plugin definitions to this file.
#
command[check_disk1]=/usr/lib/netsaint/plugins/check_disk -w 10% -c 5% -p /dev/hda1
command[check_disk2]=/usr/lib/netsaint/plugins/check_disk -w 10% -c 5% -p /dev/hda5
command[check_load]=/usr/lib/netsaint/plugins/check_load -w 15,10,5 -c 30,25,20
command[check_smtp]=/usr/lib/netsaint/plugins/check_smtp -H localhost
command[check_dead]=/usr/lib/netsaint/plugins/check_dead -w 1 -c 2 -r $first:$last
command[check_swap]=/usr/lib/netsaint/plugins/check_swap -w 75%  -c 90% 
";
}
close(OUTFILE);

print `rm -f hosterTKS$d.txt`;				#Deletes hosterTKSxxx.txt
print `apt-get install fping`;				#Installs fping. 8used by the NRPE daemon
print "NOTE!! If you use SCSI disks, you need to edit the file /etc/netsaint/command.cfg\n";
print "On the first two lines you must change /dev/hda1 with /dev/sda1 and /dev/hda5 with /dev/sda5\n";
sleep(1); 
print `cp check_dead /usr/lib/netsaint/plugins`;	#Copies the check_dead plugin to a new catalogue
print `chmod 555 /usr/lib/netsaint/plugins/check_dead`; #Changes access-rights on the plugin (read and eXecute)
print `cp command.cfg /etc/netsaint`;			#Copies command.cfg to /etc/netsaint
print `/etc/init.d/./inetd restart`;			#Restarts the inetd superserver
print "You will now have to enter the root password for the main file server\n";
print `scp hosterTKS$d.txt root\@10.0.2.2:/home/test/`;	#Copies hosterTKSxxx.txt to the FileServer
